global loader
extern kernel_main  ; Declare the external C function

section .text
align 4

MAGIC_NUMBER equ 0x1BADB002
FLAGS equ 0x0
CHECKSUM equ -MAGIC_NUMBER

dd MAGIC_NUMBER
dd FLAGS
dd CHECKSUM

loader:
    call kernel_main   ; Call the C function
    hlt                ; Halt if it returns
